/*  File: Frontier.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: execute with Frontier the text between the <FRONTIER> </FRONTIER> tags
*/

#include "OpenWorld_plugIn.h"
#include <CodeFragments.h>
#include <OSA.h>

Boolean main (dataPtr param)
{	
	switch (param->message)
	{
		case init_message:
			{	
				param->version=kVersion;
				param->customData=(long)OpenDefaultComponent(kOSAComponentType,'LAND');
			}
			break;
		
		case run_message:
			{
				AEDesc				sourceData,resultingData;
				OSAError			myOSAErr;
				long				flags;
				ComponentInstance	component;
				
				
				if (param->customData==NULL) return NULL;
				if (param->dim==NULL) return NULL;
				if (param->inputText==NULL) return NULL;
				
				component=(ComponentInstance)param->customData;
				
				/* Prepare the descriptor parameter */
				myOSAErr=AECreateDesc(typeChar,param->inputText,param->dim,&sourceData);
				
				if (myOSAErr==noErr) flags=kOSAModeNeverInteract + kOSAModeCantSwitchLayer + kOSAModeDisplayForHumans ;
				else return NULL;
				
				/* Compile, execute and convert the result*/
				myOSAErr=OSADoScript(component,&sourceData,kOSANullScript,typeChar,flags,&resultingData);
				if (myOSAErr==errOSAScriptError) myOSAErr=OSAScriptError(component,kOSAErrorMessage,typeChar,&resultingData);
				
				/* Allocate a return buffer */
				if (myOSAErr==noErr) param->dim=GetHandleSize(resultingData.dataHandle);
				else {param->dim=0;param->outputText=NULL;}
				
				if (param->dim==0) param->outputText=NULL;
					else param->outputText=OW_NewPtr(param,param->dim);
					
				if (param->outputText!=NULL) BlockMove(*(resultingData.dataHandle),param->outputText,param->dim);
					else {param->dim=0;param->outputText=NULL;}
			
				/* Dispose unused buffers */
				AEDisposeDesc(&sourceData);
				AEDisposeDesc(&resultingData);
			}
			break;
		
		case stop_message:
			{	
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
		
		case end_message:
			{	
				// close all
				CloseComponent((ComponentInstance)param->customData);
			}
			break;
	}
	// Ask OpenWorld to send the text between <FRONTIER> and </FRONTIER> in the run_message
	return kDoubleTag;
}