/*  File: Token.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: extracts tokens between the <TOKEN> </TOKEN> tags
*/

#include "OpenWorld_plugIn.h"
#include <CodeFragments.h>

Boolean main (dataPtr param)
{	
	switch (param->message)
	{
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{	
				char 	*source,*tok;
				int  	n=0,i=0,dim=0;
				char	*format,*search;
				
				if (param->search==NULL) return NULL;
				if (param->inputText==NULL) return NULL;
				
				// allocate memory
				source=OW_NewPtr(param,param->dim+1);
				if (!source) return NULL;
				
				// copy the original text into a local buffer
				strcpy(source,param->inputText);
				
				// extract the number of times to loop
				search=param->search;
				format=strchr(search,',');
				format++;
				
				dim=format-search-1;
				if (dim>0) search[dim]='\0';
				n=atoi(search);
				
				if (n==0) n=1;
				
				tok=strtok(source,format);
				
				while ((i<n-1) && (tok!=NULL))
				{		
					tok=strtok(NULL,format);
					i++;
				}
				
				// now tok contains the string to return
				dim=strlen(tok);
				if (dim)
					{
						param->outputText=OW_NewPtr(param,dim+1);
						if (param->outputText)
							{	
								strcpy(param->outputText,tok);
								param->dim=dim;
							}
						else param->dim=0;
					}
				
				// dispose the local buffer
				OW_DisposePtr(param,source);
			}
			break;
		
		case stop_message:
			{	
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
			
		case end_message:
			{	
				// do nothing
			}
			break;
	}
	// Ask OpenWorld to send the text between <TOKEN> and </TOKEN> in the run_message
	return kDoubleTag;
}