/*  File: Extract Header.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: return the selected header's field
*/

#include "OpenWorld_plugIn.h"
#include "OpenWorld_utils.h"
#include <CodeFragments.h>
#include <Packages.h>
#include <OSUtils.h>

char *up_strstr(const char * str, const char * pat);

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{	
				char		 	*header;
				char			*start,*end;
				unsigned long	size;
				unsigned long 	dim;
						
				if (param->search==NULL) return NULL;
				
				// extracts the entire HTTP request from the server
				header=OW_GetServerInfo(param,'Kfrq',&dim);
				if (!header) return NULL;
				
				// search the string 'param->search' into the header ignoring case
				start=up_strstr(header,param->search);
				if (start)
					{	
						// skip the field's name
						start+=strlen(param->search)+1;
						
						// find the end of the field
						end=strstr(start,"\r\n");
						if (end)
							{	
								// size of this field
								size=end-start;
								param->outputText=OW_NewPtr(param,size+1);
								
								// copy the entire field into the buffer
								if (param->outputText)
									{
										strncpy(param->outputText,start,size);
										param->dim=size;
									}
							}
					}
				
				// dispose the header buffer
				OW_DisposePtr(param,header);
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
			
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}