/*  File: FileSize.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: return the size of the current file
*/

#include "OpenWorld_plugIn.h"
#include "OpenWorld_utils.h"
#include <CodeFragments.h>
#include <Files.h>
#include <Packages.h>

#define oneKb 1024
#define oneMb 1024*1024

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{					
				long 		lenght;
				
				// get the file size
				if (GetEOF(param->fRef,&lenght)!=noErr) return NULL;
				
				// allocate the return buffer
				param->outputText=OW_NewPtr(param,24);
				if (param->outputText==NULL) return NULL;
				
				// convert the result size
				if (up_strcmp(param->search,"NULL")==NULL) {param->dim=sprintf(param->outputText,"%ld",lenght);}
				else
				if (lenght<oneKb) {param->dim=sprintf(param->outputText,"%ld bytes",lenght);}
				else
				if (lenght<oneMb) {lenght=lenght/oneKb; param->dim=sprintf(param->outputText,"%ld Kb",lenght);}
				else
				{lenght=lenght/oneMb; param->dim=sprintf(param->outputText,"%ld Mb",lenght);}
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
		
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}