/*  File: Insert.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: insert the file requested in the search argument
*/

#include "OpenWorld_plugIn.h"
#include "OpenWorld_utils.h"
#include <CodeFragments.h>
#include <Packages.h>
#include <OSUtils.h>

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{					
				long 	dim;
				FILE	*fRef;
				
				if (!param->search) return NULL;
				
				// open the file
				fRef=fopen(param->search,"r");
				
				if (fRef)
					{	
						// get its size
						fseek(fRef,0,SEEK_END);
						dim=ftell(fRef);
						
						// reset the position mark
						rewind(fRef);
						
						// try to allocate a buffer
						param->outputText=OW_NewPtr(param,dim);
						
						// read the file						
						if (param->outputText) param->dim=fread(param->outputText,sizeof(char),dim,fRef);

						// close the file
						fclose(fRef);		
					}
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
			
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}