/*  File: Memory.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: return memory related information
*/

#include "OpenWorld_plugIn.h"
#include "OpenWorld_utils.h"
#include <CodeFragments.h>
#include <Gestalt.h>
#include <Memory.h>

#define oneKb 1024
#define oneMb 1048576 // 1024 * 1024

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{					
				long 	size;
				
				if (up_strcmp(param->search,"PHYSICAL")==NULL) {if (Gestalt('ram ',&size)!=noErr) return NULL;} // physical ram
				else
				if (up_strcmp(param->search,"LOGICAL")==NULL) {if (Gestalt('lram',&size)!=noErr) return NULL;}	 // logical memory, physical plus virtual memory
				else
				if (up_strcmp(param->search,"AVAILABLE")==NULL) size=FreeMemSys();	// system available memory
				else
				size=FreeMem();	// default: available memory in the current heap (WebSTAR)
				
				// allocate the return buffer
				param->outputText=OW_NewPtr(param,64);
				
				if (size>=oneMb) {size=size/oneMb;if (param->outputText) param->dim=sprintf(param->outputText,"%ld Mb",size);}
				else {size=size/oneKb;if (param->outputText) param->dim=sprintf(param->outputText,"%ld Kb",size);}
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
		
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}