/*  File: ModDate.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: return the modification time of the file
*/

#include "OpenWorld_plugIn.h"
#include "OpenWorld_utils.h"
#include <CodeFragments.h>
#include <Files.h>
#include <Packages.h>

long GetFileModDate(FSSpec *spec,short fRef);

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{					
				long 		time;
				Str255		resultStr;
				
				// get the file modification date
				time=GetFileModDate(&(param->myFile),param->fRef);
				if (time==-1) return NULL;
				
				if (up_strcmp(param->search,"SEC")==NULL) IUTimeString(time,true,resultStr);	// include seconds ex: 12:05:09
				else IUTimeString(time,false,resultStr);	//without seconds ex: 12:05
				
				// allocate the return buffer
				param->outputText=OW_NewPtr(param,64);
				
				if (param->outputText) param->dim=sprintf(param->outputText,"%#s",resultStr);
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
			
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}

long GetFileModDate(FSSpec *spec,short fRef)
{
	CInfoPBRec pb;
	
	pb.hFileInfo.ioFDirIndex = 0;
	pb.hFileInfo.ioNamePtr = spec->name;
	pb.hFileInfo.ioVRefNum = spec->vRefNum;
	pb.hFileInfo.ioFRefNum = fRef;
	pb.hFileInfo.ioDirID = spec->parID;
	
	if ( PBGetCatInfoSync(&pb) == noErr ) return (pb.hFileInfo.ioFlMdDat);
	else return -1;
}