/*  File: OS Version.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: return the current Operating System Version
*/

#include "OpenWorld_plugIn.h"
#include <CodeFragments.h>
#include <Gestalt.h>

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{					
				long 		response;
				char		result[12];
				
				// get the current os version
				if (Gestalt(gestaltSystemVersion,&response)!=noErr) return NULL;
				
				sprintf(&result[0],"%X",response);
				
				// allocate the return buffer
				param->outputText=OW_NewPtr(param,12);
				
				if (param->outputText)
					{
						/* now result contains the string 851 (i.e.) */
						param->outputText[0]=result[0];
						param->outputText[1]='.';
						param->outputText[2]=result[1];
						param->outputText[3]='.';
						param->outputText[4]=result[2];
						param->outputText[5]='\0';
						param->dim=5;
					}
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
			
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}