/*  File: Server.c	  
	Copyright (c) 1999 Marco Bambini. All rights reserved.

	Description: return server's configurations
*/

#include "OpenWorld_plugIn.h"
#include "OpenWorld_utils.h"
#include <CodeFragments.h>
#include <Packages.h>
#include <OSUtils.h>
#include <string.h>

Boolean main (dataPtr param)
{	
	switch (param->message)
	{	
		case init_message:
			{
				param->version=kVersion;
				param->customData=kUnused;
			}
			break;
			
		case run_message:
			{					
				long 				dim;
				WSAPI_ParamKeywords	key;
				
				if (!param->search) return NULL;
				
				// get the ParamKeyword from the search argument
				memcpy(&key,&param->search[0],4);
				
				// get info from the server
				param->outputText=OW_GetServerInfo(param,key,&dim);
				param->dim=dim;
			}
			break;
		
		case stop_message:
			{
				// dispose the buffer
				OW_DisposePtr(param,param->outputText);
			}
			break;
			
		case end_message:
			{
				// do nothing
			}
			break;
	}
	return kSingleTag;
}